var jhmSetupBulletNav;

;(function($) {

    jhmSetupBulletNav = function(base, opt) {

        /**
         * Function: setupBulletNav
         */
        base.setupBulletNav = function()
        {
            var bulletHTMLWrapper = "<div class='jhm-bullet-wrapper'></div>";

            if(opt.pagination == 'bullet')
            {
                var bulletHTML = '<ul class="jhm-pagination jhm-pagination-' + opt.pagination + '"></ul>';
            }
            else
            {
                var bulletHTML = '<ul class="jhm-pagination jhm-pagination-' + opt.pagination + ' jhm-pagination-type-' + opt.paginationContentType + '"></ul>';
            }            
            
            base.$jhmWrapper.append(bulletHTML);
            base.$pagination = base.$jhmWrapper.children('ul.jhm-pagination');

            for (i = 0; i < base.numberSlides; i++) 
            {
                var liMarkup;

                switch(opt.pagination)
                {
                    case 'bullet':
                        if(opt.paginationBulletNumber == true)
                        {
                            liMarkup = $('<li class="jhm-slideshow-nav-pagination jhm-bullet-number">' + (i+1) + '</li>');
                        }
                        else
                        {
                            liMarkup = $('<li class="jhm-slideshow-nav-pagination"></li>');
                        }
                        break;

                    case 'content-horizontal':
                        if(opt.paginationContentType == 'text')
                        {
                            var paginationContent = opt.paginationContent.length > 0 ? opt.paginationContent[i] : "";
                            liMarkup = $('<li class="jhm-slideshow-nav-pagination">' + paginationContent + '</li>');
                        }
                        else if(opt.paginationContentType == 'image')
                        {
                            var paginationContent = typeof(opt.paginationContent[i]) != 'undefined' ? opt.paginationContent[i] : "";
                            var paginationImageAttr = typeof(opt.paginationImageAttr[i]) != 'undefined' ? opt.paginationImageAttr[i] : "";
                            liMarkup = $('<li class="jhm-slideshow-nav-pagination"><div><img src="' + paginationContent + '" ' + paginationImageAttr + ' width="' + opt.paginationContentWidth + '" height="' + opt.paginationImageHeight + '"></div></li>');      
                        }
                        break;

                    case 'content-vertical':
                        if(opt.paginationContentType == 'text')
                        {
                            var paginationContent = opt.paginationContent.length > 0 ? opt.paginationContent[i] : "";
                            liMarkup = $('<li class="jhm-slideshow-nav-pagination">' + paginationContent + '</li>');
                        }
                        else if(opt.paginationContentType == 'image')
                        {
                            var paginationContent = typeof(opt.paginationContent[i]) != 'undefined' ? opt.paginationContent[i] : "";
                            var paginationImageAttr = typeof(opt.paginationImageAttr[i]) != 'undefined' ? opt.paginationImageAttr[i] : "";
                            liMarkup = $('<li class="jhm-slideshow-nav-pagination"><img src="' + paginationContent + '" ' + paginationImageAttr + ' width="' + opt.paginationContentWidth + '" height="' + opt.paginationImageHeight + '"></li>');      
                        }
                        break;

                    default: 
                        liMarkup = $('<li class="jhm-slideshow-nav-pagination"></li>');
                }

                base.$jhmWrapper.children('ul.jhm-pagination').append(liMarkup);
                liMarkup.data('index', i);
                liMarkup.click(function () {                        
                    base.stopSliderLock();
                    base.shift($(this).data('index'));
                });
            }
           
            base.$pagination.wrap("<div class='jhm-pagination-wrapper wrapper-" + opt.pagination + "' />");                              
                      
        
            /** 
             * autohide behaviour
             */
            if(opt.pagination == 'bullet' && opt.directionalNav == 'autohide')
            {
                var btnAnimateSpeed = 300;

                base.$pagination.css("opacity", opt.directionalNavHideOpacity);

                base.$jhmWrapper.mouseenter(function(){

                    base.$pagination.stop( true, true );

                    base.$pagination.animate({
                        "opacity": opt.directionalNavShowOpacity
                    }, btnAnimateSpeed);
                });
                
                base.$jhmWrapper.mouseleave(function(){

                    base.$pagination.stop( true, true );

                    base.$pagination.animate({
                        "opacity": opt.directionalNavHideOpacity
                    }, btnAnimateSpeed);
                });
            }
        }


        /** 
         * Function: setBulletPosition
         */
        base.setBulletPosition = function()
        {
            if(opt.pagination == 'bullet')
            {
                var eachBullet = base.$pagination.children('li');
                var bulletsWidth = eachBullet.outerWidth() * base.numberSlides;
                
                var bulletsMargin = 0;

                eachBullet.each(function(index){
                    var left = $(this).css('margin-left').slice(0,-2);
                    var right = $(this).css('margin-right').slice(0,-2);

                    if(isNaN(left)) left = 0;
                    if(isNaN(right)) right = 0;

                    bulletsMargin = bulletsMargin + parseInt(left) + parseInt(right);
                });

                bulletsWidth = bulletsWidth + bulletsMargin;

                if(opt.animation == "vertical-slide")
                {
                    base.$pagination.parent().css({
                        'top': '50%',
                        'margin-top': '-' + (bulletsWidth / 2) + 'px',
                        'bottom': '0px',
                        'right': '12px'
                    });

                    eachBullet.css({
                        'float': 'none',
                        'margin-left': '0px',
                        'margin-top': '10px'
                    });

                    eachBullet.first().css('margin-top', '0px');
                }
                else
                {
                    base.$pagination.parent().css({
                        'left': '50%',
                        'margin-left': '-' + (bulletsWidth / 2) + 'px'
                    });
                }
            }
            else if(opt.pagination == 'content-horizontal')
            {
                var paginationWrapper = base.$pagination.parent('.jhm-pagination-wrapper');
                var filter = opt.paginationContentOpacity * 100;
                var sliderHeight = base.jhmHeight;
                var paginationHeight = parseInt(paginationWrapper.outerHeight());
                var textboxHeight = sliderHeight - paginationHeight;

                // set textbox height
                base.$jhmWrapper.find('.jhm-textbox').css('height',textboxHeight + 'px');

                // set opacity
                paginationWrapper.css({
                    'opacity': opt.paginationContentOpacity,
                    'filter': 'alpha(opacity=' + filter + ')'
                });
            }
        }


        /**
         * Function: setupSliderBulletNav
         */
        base.setupSliderBulletNav = function()
        {
            var spagination = 0;
            var parentWidth = 0;
            var paginationWalkingWidth = 0;
            var paginationWalkingHeight = 0;
            var paginationMaxShowedIndex = 0;
            var paginationBackChild = 0;
            var paginationNextChild = 0;
            var paginationOffsetSize = 0;
            var paginationPosition = 0;                        
            var paginationOffsetEnable = false;
            var paginationWidth = 0;
            var paginationHeight = 0;
            var paginationMovedWidth = 0;

            var imagePaginationSpace = 5;
            var eachWidth = opt.paginationContentWidth;
            var totalWidth = eachWidth * base.numberSlides;
                totalWidth = opt.paginationContentType == 'image' ? totalWidth + (imagePaginationSpace * base.numberSlides) : totalWidth;

            var eachHeight = 0;
            var totalHeight = 0;

            // vertical or horizontal
            var dirType = opt.pagination;
                dirType = dirType.substring(8);

            // first init horizontal bullet slider dimension
            if(dirType == 'horizontal')
            {
                var spagination = base.$jhmWrapper.find('ul.jhm-pagination-' + opt.pagination);
                spagination.width(totalWidth);
            }
            
            /**
             * generate slide bullet 
             * this function will be recall every slideshow resized
             */
            this.generateSlideBullet = function()
            {
                spagination = base.$jhmWrapper.find('ul.jhm-pagination-' + opt.pagination);
                
                var containerWidth = spagination.parent().outerWidth(true);

                parentWidth = containerWidth;
                paginationWalkingWidth = 0;
                paginationWalkingHeight = 0;
                paginationMaxShowedIndex = 0;
                paginationBackChild = 0;
                paginationNextChild = 0;
                paginationOffsetSize = 0;
                paginationPosition = 0;                        
                paginationOffsetEnable = false;              
                                
                spagination.parent().css('overflow', 'hidden');
                spagination.css('background-color', spagination.children('li').last().css("background-color"));
                spagination.children('li.jhm-slideshow-nav-pagination').css('width',eachWidth + 'px');                
                                
                setupPaginationPosition(); // vertical or horizontal
                setupPaginationWidth(); // vertical or horizontal
                setupWalkingPagination(); // vertical or horizontal

                function setupPaginationPosition()
                {
                    if(dirType == 'vertical')
                    {
                        /** 
                         * A complicated vertical positioning 
                         */
                        eachHeight = spagination.children('li').outerHeight();
                        totalHeight = eachHeight * base.numberSlides;

                        spagination.css('width', eachWidth + 'px');
                        spagination.parent().css({
                            'width': eachWidth + 'px',
                            'right': 0 + 'px',
                            'height': base.jhmHeight + 'px'
                        });

                        // wrapper and container
                        base.$el.css({
                            'height': base.jhmHeight + 'px'
                        });

                        base.$jhm.css({
                            'margin-left': '0px'
                        });
                    }
                    else
                    {
                        spagination.width(totalWidth);
                    }
                }

                function setupPaginationWidth()
                {
                    /** 
                     * vertical vs horizontal
                     */

                    if(dirType == 'vertical')
                    {
                        paginationHeight = base.jhmHeight;

                        if(paginationHeight > totalHeight)
                        {
                            paginationHeight = totalHeight;
                        }
                    }
                    else
                    {
                        // paginationWidth = spagination.parent().outerWidth(true);
                        paginationWidth = containerWidth;

                        if(paginationWidth > totalWidth)
                        {
                            if(opt.paginationContentFullWidth)
                            {
                                eachWidth = paginationWidth / base.numberSlides;
                                totalWidth = eachWidth * base.numberSlides;
                            }
                            else paginationWidth = totalWidth;                  
                        }
                    }
                }

                function setupWalkingPagination()
                {
                    spagination.find('li').each(function () {

                        /** 
                         * vertical vs horizontal
                         */

                        if(dirType == 'vertical')
                        {
                            paginationWalkingHeight += eachHeight;

                            if (paginationWalkingHeight + eachHeight > paginationHeight) 
                            {
                                paginationNextChild = $(this).index();
                                paginationMaxShowedIndex = paginationNextChild;
                            }

                            if (paginationWalkingHeight > paginationHeight) 
                            {
                                $(this).addClass('jhm-bullet-sliding-next');
                                paginationOffsetSize = paginationWalkingHeight - paginationHeight;

                                /* detect if pagination offset is too large */
                                if(paginationOffsetSize < eachHeight)
                                {
                                    paginationOffsetEnable = true;
                                }

                                return false;
                            }
                        }
                        else
                        {
                            paginationWalkingWidth += eachWidth;

                            if (paginationWalkingWidth + eachWidth > paginationWidth) 
                            {
                                paginationNextChild = $(this).index();
                                paginationMaxShowedIndex = paginationNextChild;
                            }

                            if (paginationWalkingWidth > paginationWidth) 
                            {
                                $(this).addClass('jhm-bullet-sliding-next');
                                paginationOffsetSize = paginationWalkingWidth - paginationWidth;

                                /* detect if pagination offset is too large */
                                if(paginationOffsetSize < eachWidth)
                                {
                                    paginationOffsetEnable = true;
                                }

                                return false;
                            }
                        }
                    });
                }
            }

            this.slideBullet = function(navigate)
            {
                /** 
                 * vertical vs horizontal
                 */
                if(dirType == 'vertical')
                {
                    var eachDimension = eachHeight;
                }
                else
                {
                    var eachDimension = eachWidth;
                }

                var paginationNavPixelSize = 0;

                if(navigate == 'next')
                {
                    if(spagination.children('li').eq(base.numberSlides - 1).hasClass("jhm-bullet-sliding-next"))
                    {
                        paginationNavPixelSize = (eachDimension * paginationPosition) + paginationOffsetSize;
                    }
                    else
                    {
                        spagination.children('li').removeClass('jhm-bullet-sliding-back').removeClass('jhm-bullet-sliding-next');

                        paginationPosition++;
                        paginationBackChild++;
                        paginationNextChild++;

                        paginationNavPixelSize = (eachDimension * paginationPosition) + paginationOffsetSize;
                    }

                    slideBulletAddClass('sliding_one','jhm-bullet-sliding-one-back',paginationBackChild + 1)            
                }
                else if(navigate == 'back')
                {
                    spagination.children('li').removeClass('jhm-bullet-sliding-back').removeClass('jhm-bullet-sliding-next');

                    paginationPosition--;
                    paginationBackChild--;
                    paginationNextChild--;

                    paginationNavPixelSize = eachDimension * paginationPosition;

                    slideBulletAddClass('sliding_one','jhm-bullet-sliding-one-next',paginationNextChild - 1)
                }
                else if(navigate == 'first')
                {
                    spagination.children('li').removeClass('jhm-bullet-sliding-back').removeClass('jhm-bullet-sliding-next');

                    paginationPosition = 0;
                    paginationBackChild = 0;                    
                    paginationNextChild = paginationMaxShowedIndex;

                    paginationNavPixelSize = eachDimension * paginationPosition;

                    slideBulletAddClass('sliding_one','jhm-bullet-sliding-one-next',paginationNextChild - 1)
                }
                else if(navigate == 'last')
                {
                    spagination.children('li').removeClass('jhm-bullet-sliding-back').removeClass('jhm-bullet-sliding-next');

                    var numberBulletsByIndex = base.numberSlides - 1;

                    paginationPosition = numberBulletsByIndex - paginationMaxShowedIndex;
                    paginationBackChild = numberBulletsByIndex - paginationMaxShowedIndex;
                    paginationNextChild = numberBulletsByIndex;

                    paginationNavPixelSize = (eachDimension * paginationPosition) + paginationOffsetSize;

                    slideBulletAddClass('sliding_one','jhm-bullet-sliding-one-back',paginationBackChild + 1)
                }

                /**
                 * Track moved width
                 */
                paginationMovedWidth = paginationNavPixelSize;
                trackMovedWidth(paginationMovedWidth);                
                
                // Apply class to bullet
                slideBulletAddClass('sliding', 'jhm-bullet-sliding-back', paginationBackChild)
                slideBulletAddClass('sliding', 'jhm-bullet-sliding-next', paginationNextChild)
            }

            function slideBulletAddClass(li_type, li_class, li_index)
            {
                if(li_type == 'sliding_one')
                {
                    if(paginationOffsetEnable == true)
                    {
                        spagination.children('li').removeClass('jhm-bullet-sliding-one-back').removeClass('jhm-bullet-sliding-one-next');
                        
                        var addClassTo = spagination.children('li').eq(li_index)

                        if(addClassTo.attr('class') == "jhm-slideshow-nav-pagination")
                        {
                            addClassTo.addClass(li_class);
                        }                        
                    }
                }  
                else if(li_type == 'sliding')
                {
                    if(spagination.children('li').eq(li_index).attr('class') == 'jhm-slideshow-nav-pagination jhm-pagination-active' && li_index > 0 )
                    {
                        if(li_class == 'jhm-bullet-sliding-back')
                        {
                            li_index--
                        }
                        else if(li_class == 'jhm-bullet-sliding-next')
                        {
                            li_index++
                        }
                    }

                    spagination.children('li').eq(li_index).removeClass('jhm-bullet-sliding-one-back')
                    spagination.children('li').eq(li_index).removeClass('jhm-bullet-sliding-one-next')
                    spagination.children('li').eq(li_index).addClass(li_class)
                }
            }

            function slideBulletOne(type)
            {
                var oneMove = 0;

                spagination.children('li').removeClass('jhm-bullet-sliding-one-back').removeClass('jhm-bullet-sliding-one-next');

                if(type == 'back')
                {
                    spagination.children('li').eq(paginationNextChild - 1).addClass('jhm-bullet-sliding-one-next');

                    oneMove = paginationMovedWidth - paginationOffsetSize;
                }
                else
                {
                    spagination.children('li').eq(paginationBackChild + 1).addClass('jhm-bullet-sliding-one-back');

                    oneMove = paginationMovedWidth + paginationOffsetSize;
                }

                /**
                 * Track moved width
                 */
                paginationMovedWidth = oneMove;
                trackMovedWidth(paginationMovedWidth);
            }

            function trackMovedWidth(move)
            {
                /** 
                 * vertical vs horizontal
                 */
                if(dirType == 'vertical')
                {
                    var transform = 'translate3d(0, -' + move + 'px, 0)';
                    var direction = 'down';
                }
                else
                {
                    var transform = 'translate3d(-' + move + 'px, 0, 0)';
                    var direction = 'left';
                }

                if(parentWidth < totalWidth)
                {
                    if(base.css3support())
                    {
                        var properties = {};
                        properties[ '-' + base.vendorPrefix + '-transition-duration' ] = opt.animationSpeed + 'ms';
                        properties[ '-' + base.vendorPrefix + '-transform' ] = transform;

                        spagination.css(properties);
                    }
                    else
                    {
                        spagination
                            .animate({
                                direction: '-' + move + 'px'
                            }, opt.animationSpeed);
                    }
                }
            }


            /**
             * SET ACTIVE BULLETS
             */
            this.setActiveBullet = function() 
            {
                if (opt.pagination == 'none') {
                    return false;
                } else {
                    base.$pagination.children('li').removeClass('jhm-pagination-active').eq(base.activeSlide).addClass('jhm-pagination-active');

                    /**
                     * begin slide pagination
                     */
                    if(opt.pagination == 'content-horizontal' || opt.pagination == 'content-vertical')
                    {
                        this.beginSlideBullet();
                    }
                }
            }

            this.beginSlideBullet = function()
            {
                var activeBullet = base.$pagination.children('li.jhm-pagination-active');
                
                var positionFirst = activeBullet.index() == 0 ? true : false;
                var positionMiddle = activeBullet.index() > 0 ? true : false;
                var positionLast = activeBullet.index() == (base.numberSlides-1) ? true : false;

                if(activeBullet.hasClass('jhm-bullet-sliding-next'))
                {
                    if(positionLast) this.slideBullet('last');
                    else this.slideBullet('next');
                }
                else if(activeBullet.hasClass('jhm-bullet-sliding-back'))
                {
                    if(positionMiddle) this.slideBullet('back');
                    else this.slideBullet('first');
                }
                else if(activeBullet.hasClass('jhm-bullet-sliding-one-next'))
                {
                    slideBulletOne('next')
                }
                else if(activeBullet.hasClass('jhm-bullet-sliding-one-back'))
                {
                    slideBulletOne('back')
                }
                else
                {
                    if(paginationMaxShowedIndex > 0)
                    {
                        if(positionFirst) this.slideBullet('first');
                        else if(positionLast) this.slideBullet('last');
                    }
                }
            }
        }
    }

})(jQuery);