var jhmSetupLayout;

;(function($) {

    jhmSetupLayout = function(base, opt) {

        /**
         * Function: setupLayout
         */
        base.setupLayout = function()
        {
            /**
             * Force change option value
             */
            setupOptions(opt);
            function setupOptions(opt)
            {
                if(opt.carousel)
                {
                    opt.animation = 'horizontal-slide';
                    opt.continousSliding = true;
                    opt.directionalNav = 'show';
                }

                if(opt.animation == 'fade')
                {
                    opt.continousSliding = false;
                }
            }

            // general layout
            base.calculateHeightWidth();

            if(opt.animation == "horizontal-slide")
            {
                base.$slides.css({
                    "position": "relative",
                    "float": "left",
                    "display": "block",
                    "width": base.jhmWidth + "px",
                    "height": + "100%"
                });

                if(opt.continousSliding)
                {
                    slideWrapperInside1st = '<div class="slideWrapperInside swi1st">' + base.$slideWrapper.html() + '</div>';
                    slideWrapperInside2nd = '<div class="slideWrapperInside swi2nd">' + base.$slideWrapper.html() + '</div>';
                    slideWrapperInside3rd = '<div class="slideWrapperInside swi3rd">' + base.$slideWrapper.html() + '</div>';
                    base.$slideWrapper.html(slideWrapperInside1st + slideWrapperInside2nd + slideWrapperInside3rd);
                }
                else
                {  
                    base.$slideWrapper.css({"width": base.jhmWidth * base.numberSlides + "px", "height": base.jhmHeight + "px"});
                }
            }
            else if(opt.animation == "vertical-slide")
            {
                base.$slides.css({
                    "position": "relative",
                    "display": "block",
                    "overflow": "hidden",
                    "width": base.jhmWidth + "px",
                    "height": base.jhmHeight + "px"
                });

                if(opt.continousSliding)
                {
                    slideWrapperInside1st = '<div class="slideWrapperInside swi1st">' + base.$slideWrapper.html() + '</div>';
                    slideWrapperInside2nd = '<div class="slideWrapperInside swi2nd">' + base.$slideWrapper.html() + '</div>';
                    slideWrapperInside3rd = '<div class="slideWrapperInside swi3rd">' + base.$slideWrapper.html() + '</div>';
                    base.$slideWrapper.html(slideWrapperInside1st + slideWrapperInside2nd + slideWrapperInside3rd);
                }
                else
                {
                    base.$slideWrapper.css({"width": base.jhmWidth + "px", "height": base.jhmHeight * base.numberSlides + "px"});
                }
            }
            else if(opt.animation == "fade")
            {
                base.$slides.css({
                    "opacity": 0,
                    "z-index": 1
                });

                base.$slides.eq(base.activeSlide).css({
                    "z-index": 3,
                    "opacity": 1
                });
                
                base.$slideWrapper.css({"width": base.jhmWidth + "px", "height": base.jhmHeight + "px"});
            }

            // set background
            base.$jhm.css('background-color', opt.background);

            // init isRunning
            base.isRunning = false;

            // set current slide
            if(opt.continousSliding)
            {
                base.$currentSlide = base.$slideWrapper.children('.slideWrapperInside.swi2nd').children().eq(0);
            }
            else
            {
                base.$currentSlide = base.$slideWrapper.children().eq(0);
            }

            base.$slideWrapper.css('left', '0px');
        }


        /**
         * Function: setupCarousel
         */
        base.setupCarousel = function()
        {
            if(! opt.carousel) return;

            var left = (100 - opt.carouselWidth) / 2;
                left = base.originaljhmWidth * left / 100;

            base.$slideWrapper.css('left', left + 'px');

            // navigation
            var btn = base.$jhmWrapper.children('div.jhm-slider-nav').children('span');
                        
            btn.css({
                'top': '0px',
                'margin-top': '0px',
                'background': 'none',
                'width': left + 'px',
                'height': base.jhmHeight + 'px'
            });

            // blur
            base.doBlur(false,false,opt.carouselOpacity);
            base.doBlur('.swi2nd',0,1);
        }


        /**
         * Function: doBlur
         */
        base.doBlur = function(parentClass,childNumber,valueBlur)
        {
            var transition = '-' + base.vendorPrefix + '-transition';

            if(!parentClass && !childNumber)
            {
                base.$slideWrapper.children().children()
                    .css({
                        'opacity': valueBlur,
                        'filter': 'alpha(opacity=' + valueBlur*100 + ')',
                        transition: 'opacity ' + opt.animationSpeed + 'ms ease-in-out'
                    });
            }
            else
            {
                base.$slideWrapper.children(parentClass).children().eq(childNumber)
                    .css({
                        'opacity': valueBlur,
                        'filter': 'alpha(opacity=' + valueBlur*100 + ')',
                        transition: 'opacity ' + opt.animationSpeed + 'ms ease-in-out'
                    });
            }
        }
    }

})(jQuery);